diff --git a/gcc/analyzer/checker-event.cc b/gcc/analyzer/checker-event.cc
index 57e36d470e8..bd62e3887a6 100644
--- a/gcc/analyzer/checker-event.cc
+++ b/gcc/analyzer/checker-event.cc
@@ -77,10 +77,10 @@ event_kind_to_string (enum event_kind ek)
       return "end_cfg_edge";
     case event_kind::catch_:
       return "catch";
-    case event_kind::call_edge:
-      return "call_edge";
-    case event_kind::return_edge:
-      return "return_edge";
+    case event_kind::call_:
+      return "call";
+    case event_kind::return_:
+      return "return";
     case event_kind::start_consolidated_cfg_edges:
       return "start_consolidated_cfg_edges";
     case event_kind::end_consolidated_cfg_edges:
@@ -379,8 +379,7 @@ region_creation_event_debug::print_desc (pretty_printer &pp) const
 function_entry_event::function_entry_event (const program_point &dst_point,
 					    const program_state &state)
 : checker_event (event_kind::function_entry,
-		 event_loc_info (dst_point.get_supernode
-				   ()->get_start_location (),
+		 event_loc_info (dst_point.get_location (),
 				 dst_point.get_fndecl (),
 				 dst_point.get_stack_depth ())),
   m_state (state)
@@ -411,9 +410,8 @@ function_entry_event::get_meaning () const
 
 /* state_change_event's ctor.  */
 
-state_change_event::state_change_event (const supernode *node,
+state_change_event::state_change_event (const event_loc_info &loc_info,
 					const gimple *stmt,
-					int stack_depth,
 					const state_machine &sm,
 					const svalue *sval,
 					state_machine::state_t from,
@@ -421,11 +419,9 @@ state_change_event::state_change_event (const supernode *node,
 					const svalue *origin,
 					const program_state &dst_state,
 					const exploded_node *enode)
-: checker_event (event_kind::state_change,
-		 event_loc_info (stmt->location,
-				 node->m_fun->decl,
-				 stack_depth)),
-  m_node (node), m_stmt (stmt), m_sm (sm),
+: checker_event (event_kind::state_change, loc_info),
+  m_stmt (stmt),
+  m_sm (sm),
   m_sval (sval), m_from (from), m_to (to),
   m_origin (origin),
   m_dst_state (dst_state),
@@ -551,43 +547,26 @@ maybe_add_sarif_properties (diagnostics::sarif_builder &builder,
 #undef PROPERTY_PREFIX
 }
 
-/* Get the callgraph_superedge for this superedge_event, which must be
-   for an interprocedural edge, rather than a CFG edge.  */
-
-const callgraph_superedge&
-superedge_event::get_callgraph_superedge () const
-{
-  gcc_assert (m_sedge->m_kind != SUPEREDGE_CFG_EDGE);
-  return *m_sedge->dyn_cast_callgraph_superedge ();
-}
-
 /* Determine if this event should be filtered at the given verbosity
    level.  */
 
 bool
 superedge_event::should_filter_p (int verbosity) const
 {
-  switch (m_sedge->m_kind)
+  if (m_sedge->get_any_cfg_edge ())
     {
-    case SUPEREDGE_CFG_EDGE:
-      {
-	if (verbosity < 2)
-	  return true;
-
-	if (verbosity < 4)
-	  {
-	    /* Filter events with empty descriptions.  This ought to filter
-	       FALLTHRU, but retain true/false/switch edges.  */
-	    auto pp = global_dc->clone_printer ();
-	    print_desc (*pp.get ());
-	    if (pp_formatted_text (pp.get ()) [0] == '\0')
-	      return true;
-	  }
-      }
-      break;
+      if (verbosity < 2)
+	return true;
 
-    default:
-      break;
+      if (verbosity < 4)
+	{
+	  /* Filter events with empty descriptions.  This ought to filter
+	     FALLTHRU, but retain true/false/switch edges.  */
+	  auto pp = global_dc->clone_printer ();
+	  print_desc (*pp.get ());
+	  if (pp_formatted_text (pp.get ()) [0] == '\0')
+	    return true;
+	}
     }
   return false;
 }
@@ -598,37 +577,37 @@ superedge_event::get_program_state () const
   return &m_eedge.m_dest->get_state ();
 }
 
+const call_and_return_op *
+superedge_event::get_call_and_return_op () const
+{
+  if (m_sedge)
+    if (auto base_op = m_sedge->get_op ())
+      return base_op->dyn_cast_call_and_return_op ();
+  return nullptr;
+}
+
 /* superedge_event's ctor.  */
 
 superedge_event::superedge_event (enum event_kind kind,
 				  const exploded_edge &eedge,
 				  const event_loc_info &loc_info)
 : checker_event (kind, loc_info),
-  m_eedge (eedge), m_sedge (eedge.m_sedge),
-  m_var (NULL_TREE), m_critical_state (0)
+  m_eedge (eedge), m_sedge (eedge.m_sedge)
 {
-  /* Note that m_sedge can be nullptr for e.g. jumps through
-     function pointers.  */
+  gcc_assert (m_sedge);
 }
 
 /* class cfg_edge_event : public superedge_event.  */
 
-/* Get the cfg_superedge for this cfg_edge_event.  */
-
-const cfg_superedge &
-cfg_edge_event::get_cfg_superedge () const
-{
-  return *m_sedge->dyn_cast_cfg_superedge ();
-}
-
 /* cfg_edge_event's ctor.  */
 
 cfg_edge_event::cfg_edge_event (enum event_kind kind,
 				const exploded_edge &eedge,
-				const event_loc_info &loc_info)
-: superedge_event (kind, eedge, loc_info)
+				const event_loc_info &loc_info,
+				const control_flow_op *op)
+: superedge_event (kind, eedge, loc_info),
+  m_op (op)
 {
-  gcc_assert (eedge.m_sedge->m_kind == SUPEREDGE_CFG_EDGE);
 }
 
 /* Implementation of diagnostics::paths::event::get_meaning vfunc for
@@ -637,13 +616,20 @@ cfg_edge_event::cfg_edge_event (enum event_kind kind,
 diagnostics::paths::event::meaning
 cfg_edge_event::get_meaning () const
 {
-  const cfg_superedge& cfg_sedge = get_cfg_superedge ();
-  if (cfg_sedge.true_value_p ())
-    return meaning (verb::branch, property::true_);
-  else if (cfg_sedge.false_value_p ())
-    return meaning (verb::branch, property::false_);
-  else
-    return meaning ();
+  if (::edge e = get_cfg_edge ())
+    {
+      if (e->flags & EDGE_TRUE_VALUE)
+	return meaning (verb::branch, property::true_);
+      else if (e->flags & EDGE_FALSE_VALUE)
+	return meaning (verb::branch, property::false_);
+    }
+  return meaning ();
+}
+
+::edge
+cfg_edge_event::get_cfg_edge () const
+{
+  return m_sedge->get_any_cfg_edge ();
 }
 
 /* class start_cfg_edge_event : public cfg_edge_event.  */
@@ -675,9 +661,12 @@ start_cfg_edge_event::print_desc (pretty_printer &pp) const
   label_text edge_desc (m_sedge->get_description (user_facing));
   if (user_facing)
     {
-      if (edge_desc.get () && strlen (edge_desc.get ()) > 0)
+      if (edge_desc.get ()
+	  && strlen (edge_desc.get ()) > 0
+	  && m_op)
 	{
-	  label_text cond_desc = maybe_describe_condition (pp_show_color (&pp));
+	  label_text cond_desc
+	    = m_op->maybe_describe_condition (pp_show_color (&pp));
 	  label_text result;
 	  if (cond_desc.get ())
 	    pp_printf (&pp,
@@ -695,145 +684,16 @@ start_cfg_edge_event::print_desc (pretty_printer &pp) const
 	return pp_printf (&pp,
 			  "taking %qs edge SN:%i -> SN:%i",
 			  edge_desc.get (),
-			  m_sedge->m_src->m_index,
-			  m_sedge->m_dest->m_index);
+			  m_sedge->m_src->m_id,
+			  m_sedge->m_dest->m_id);
       else
 	return pp_printf (&pp,
 			  "taking edge SN:%i -> SN:%i",
-			  m_sedge->m_src->m_index,
-			  m_sedge->m_dest->m_index);
+			  m_sedge->m_src->m_id,
+			  m_sedge->m_dest->m_id);
     }
 }
 
-/* Attempt to generate a description of any condition that holds at this edge.
-
-   The intent is to make the user-facing messages more clear, especially for
-   cases where there's a single or double-negative, such as
-   when describing the false branch of an inverted condition.
-
-   For example, rather than printing just:
-
-      |  if (!ptr)
-      |     ~
-      |     |
-      |     (1) following 'false' branch...
-
-   it's clearer to spell out the condition that holds:
-
-      |  if (!ptr)
-      |     ~
-      |     |
-      |     (1) following 'false' branch (when 'ptr' is non-NULL)...
-                                          ^^^^^^^^^^^^^^^^^^^^^^
-
-   In the above example, this function would generate the highlighted
-   string: "when 'ptr' is non-NULL".
-
-   If the edge is not a condition, or it's not clear that a description of
-   the condition would be helpful to the user, return NULL.  */
-
-label_text
-start_cfg_edge_event::maybe_describe_condition (bool can_colorize) const
-{
-  const cfg_superedge& cfg_sedge = get_cfg_superedge ();
-
-  if (cfg_sedge.true_value_p () || cfg_sedge.false_value_p ())
-    {
-      const gimple *last_stmt = m_sedge->m_src->get_last_stmt ();
-      if (const gcond *cond_stmt = dyn_cast <const gcond *> (last_stmt))
-	{
-	  enum tree_code op = gimple_cond_code (cond_stmt);
-	  tree lhs = gimple_cond_lhs (cond_stmt);
-	  tree rhs = gimple_cond_rhs (cond_stmt);
-	  if (cfg_sedge.false_value_p ())
-	    op = invert_tree_comparison (op, false /* honor_nans */);
-	  return maybe_describe_condition (can_colorize,
-					   lhs, op, rhs);
-	}
-    }
-  return label_text::borrow (nullptr);
-}
-
-/* Subroutine of maybe_describe_condition above.
-
-   Attempt to generate a user-facing description of the condition
-   LHS OP RHS, but only if it is likely to make it easier for the
-   user to understand a condition.  */
-
-label_text
-start_cfg_edge_event::maybe_describe_condition (bool can_colorize,
-						tree lhs,
-						enum tree_code op,
-						tree rhs)
-{
-  /* In theory we could just build a tree via
-       fold_build2 (op, boolean_type_node, lhs, rhs)
-     and print it with %qE on it, but this leads to warts such as
-     parenthesizing vars, such as '(i) <= 9', and uses of '<unknown>'.  */
-
-  /* Special-case: describe testing the result of strcmp, as figuring
-     out what the "true" or "false" path is can be confusing to the user.  */
-  if (TREE_CODE (lhs) == SSA_NAME
-      && zerop (rhs))
-    {
-      if (gcall *call = dyn_cast <gcall *> (SSA_NAME_DEF_STMT (lhs)))
-	if (is_special_named_call_p (*call, "strcmp", 2))
-	  {
-	    if (op == EQ_EXPR)
-	      return label_text::borrow ("when the strings are equal");
-	    if (op == NE_EXPR)
-	      return label_text::borrow ("when the strings are non-equal");
-	  }
-    }
-
-  /* Only attempt to generate text for sufficiently simple expressions.  */
-  if (!should_print_expr_p (lhs))
-    return label_text::borrow (nullptr);
-  if (!should_print_expr_p (rhs))
-    return label_text::borrow (nullptr);
-
-  /* Special cases for pointer comparisons against NULL.  */
-  if (POINTER_TYPE_P (TREE_TYPE (lhs))
-      && POINTER_TYPE_P (TREE_TYPE (rhs))
-      && zerop (rhs))
-    {
-      if (op == EQ_EXPR)
-	return make_label_text (can_colorize, "when %qE is NULL",
-				lhs);
-      if (op == NE_EXPR)
-	return make_label_text (can_colorize, "when %qE is non-NULL",
-				lhs);
-    }
-
-  return make_label_text (can_colorize, "when %<%E %s %E%>",
-			  lhs, op_symbol_code (op), rhs);
-}
-
-/* Subroutine of maybe_describe_condition.
-
-   Return true if EXPR is we will get suitable user-facing output
-   from %E on it.  */
-
-bool
-start_cfg_edge_event::should_print_expr_p (tree expr)
-{
-  if (TREE_CODE (expr) == SSA_NAME)
-    {
-      if (SSA_NAME_VAR (expr))
-	return should_print_expr_p (SSA_NAME_VAR (expr));
-      else
-	return false;
-    }
-
-  if (DECL_P (expr))
-    return true;
-
-  if (CONSTANT_CLASS_P (expr))
-    return true;
-
-  return false;
-}
-
 /* class catch_cfg_edge_event : public cfg_edge_event.  */
 
 diagnostics::paths::event::meaning
@@ -848,11 +708,8 @@ catch_cfg_edge_event::get_meaning () const
 
 call_event::call_event (const exploded_edge &eedge,
 			const event_loc_info &loc_info)
-: superedge_event (event_kind::call_edge, eedge, loc_info)
+: superedge_event (event_kind::call_, eedge, loc_info)
 {
-  if (eedge.m_sedge)
-    gcc_assert (eedge.m_sedge->m_kind == SUPEREDGE_CALL);
-
    m_src_snode = eedge.m_src->get_supernode ();
    m_dest_snode = eedge.m_dest->get_supernode ();
 }
@@ -871,14 +728,14 @@ call_event::call_event (const exploded_edge &eedge,
 void
 call_event::print_desc (pretty_printer &pp) const
 {
-  if (m_critical_state && m_pending_diagnostic)
+  if (m_critical_state.m_state && m_pending_diagnostic)
     {
-      gcc_assert (m_var);
-      tree var = fixup_tree_for_diagnostic (m_var);
+      gcc_assert (m_critical_state.m_var);
+      tree var = fixup_tree_for_diagnostic (m_critical_state.m_var);
       evdesc::call_with_state evd (m_src_snode->m_fun->decl,
 				   m_dest_snode->m_fun->decl,
 				   var,
-				   m_critical_state);
+				   m_critical_state.m_state);
       if (m_pending_diagnostic->describe_call_with_state (pp, evd))
 	return;
     }
@@ -926,19 +783,19 @@ call_event::get_program_state () const
   return &m_eedge.m_src->get_state ();
 }
 
-/* class return_event : public superedge_event.  */
+/* class return_event : public checker_event.  */
 
 /* return_event's ctor.  */
 
 return_event::return_event (const exploded_edge &eedge,
 			    const event_loc_info &loc_info)
-: superedge_event (event_kind::return_edge, eedge, loc_info)
+: checker_event (event_kind::return_, loc_info),
+  m_eedge (eedge)
 {
-  if (eedge.m_sedge)
-    gcc_assert (eedge.m_sedge->m_kind == SUPEREDGE_RETURN);
-
   m_src_snode = eedge.m_src->get_supernode ();
   m_dest_snode = eedge.m_dest->get_supernode ();
+  m_call_and_return_op
+    = eedge.m_src->get_point ().get_call_string ().get_top_of_stack ().m_call_op;
 }
 
 /* Implementation of diagnostics::paths::event::print_desc vfunc for
@@ -959,11 +816,11 @@ return_event::print_desc (pretty_printer &pp) const
       state involved in the pending diagnostic, give the pending
       diagnostic a chance to describe this return (in terms of
       itself).  */
-  if (m_critical_state && m_pending_diagnostic)
+  if (m_critical_state.m_state && m_pending_diagnostic)
     {
       evdesc::return_of_state evd (m_dest_snode->m_fun->decl,
 				   m_src_snode->m_fun->decl,
-				   m_critical_state);
+				   m_critical_state.m_state);
       if (m_pending_diagnostic->describe_return_of_state (pp, evd))
 	return;
     }
diff --git a/gcc/analyzer/checker-event.h b/gcc/analyzer/checker-event.h
index fc51be10c95..f79130ffb38 100644
--- a/gcc/analyzer/checker-event.h
+++ b/gcc/analyzer/checker-event.h
@@ -42,8 +42,8 @@ enum class event_kind
   start_cfg_edge,
   end_cfg_edge,
   catch_,
-  call_edge,
-  return_edge,
+  call_,
+  return_,
   start_consolidated_cfg_edges,
   end_consolidated_cfg_edges,
   inlined_call,
@@ -76,8 +76,8 @@ extern const char *event_kind_to_string (enum event_kind ek);
 	   start_cfg_edge_event (event_kind::start_cfg_edge)
 	   end_cfg_edge_event (event_kind::end_cfg_edge)
 	   catch_cfg_edge_event (event_kind::catch_cfg_edge)
-         call_event (event_kind::call_edge)
-         return_edge (event_kind::return_edge)
+	 call_event (event_kind::call_)
+       return_event (event_kind::return_)
        start_consolidated_cfg_edges_event (event_kind::start_consolidated_cfg_edges)
        end_consolidated_cfg_edges_event (event_kind::end_consolidated_cfg_edges)
        inlined_call_event (event_kind::inlined_call)
@@ -381,8 +381,8 @@ private:
 class state_change_event : public checker_event
 {
 public:
-  state_change_event (const supernode *node, const gimple *stmt,
-		      int stack_depth,
+  state_change_event (const event_loc_info &loc_info,
+		      const gimple *stmt,
 		      const state_machine &sm,
 		      const svalue *sval,
 		      state_machine::state_t from,
@@ -407,7 +407,6 @@ public:
 
   const exploded_node *get_exploded_node () const { return m_enode; }
 
-  const supernode *m_node;
   const gimple *m_stmt;
   const state_machine &m_sm;
   const svalue *m_sval;
@@ -429,23 +428,14 @@ public:
 			      diagnostics::sarif_object &thread_flow_loc_obj)
     const override;
 
-  /* Mark this edge event as being either an interprocedural call or
-     return in which VAR is in STATE, and that this is critical to the
-     diagnostic (so that print_desc can attempt to get a better description
-     from any pending_diagnostic).  */
-  void record_critical_state (tree var, state_machine::state_t state)
-  {
-    m_var = var;
-    m_critical_state = state;
-  }
-
-  const callgraph_superedge& get_callgraph_superedge () const;
-
   bool should_filter_p (int verbosity) const;
 
   const program_state *
   get_program_state () const override;
 
+  virtual const call_and_return_op *
+  get_call_and_return_op () const;
+
  protected:
   superedge_event (enum event_kind kind, const exploded_edge &eedge,
 		   const event_loc_info &loc_info);
@@ -453,8 +443,6 @@ public:
  public:
   const exploded_edge &m_eedge;
   const superedge *m_sedge;
-  tree m_var;
-  state_machine::state_t m_critical_state;
 };
 
 /* An abstract event subclass for when a CFG edge is followed; it has two
@@ -466,11 +454,15 @@ class cfg_edge_event : public superedge_event
 public:
   meaning get_meaning () const override;
 
-  const cfg_superedge& get_cfg_superedge () const;
+  ::edge get_cfg_edge () const;
 
  protected:
-  cfg_edge_event (enum event_kind kind, const exploded_edge &eedge,
-		  const event_loc_info &loc_info);
+  cfg_edge_event (enum event_kind kind,
+		  const exploded_edge &eedge,
+		  const event_loc_info &loc_info,
+		  const control_flow_op *op);
+
+  const control_flow_op *m_op;
 };
 
 /* A concrete event subclass for the start of a CFG edge
@@ -480,22 +472,16 @@ class start_cfg_edge_event : public cfg_edge_event
 {
 public:
   start_cfg_edge_event (const exploded_edge &eedge,
-			const event_loc_info &loc_info)
-  : cfg_edge_event (event_kind::start_cfg_edge, eedge, loc_info)
+			const event_loc_info &loc_info,
+			const control_flow_op *op)
+  : cfg_edge_event (event_kind::start_cfg_edge, eedge, loc_info, op)
   {
   }
 
   void print_desc (pretty_printer &pp) const override;
   bool connect_to_next_event_p () const final override { return true; }
 
-protected:
-  label_text maybe_describe_condition (bool can_colorize) const;
-
 private:
-  static label_text maybe_describe_condition (bool can_colorize,
-					      tree lhs,
-					      enum tree_code op,
-					      tree rhs);
   static bool should_print_expr_p (tree);
 };
 
@@ -506,8 +492,9 @@ class end_cfg_edge_event : public cfg_edge_event
 {
 public:
   end_cfg_edge_event (const exploded_edge &eedge,
-		      const event_loc_info &loc_info)
-  : cfg_edge_event (event_kind::end_cfg_edge, eedge, loc_info)
+		      const event_loc_info &loc_info,
+		      const control_flow_op *op)
+  : cfg_edge_event (event_kind::end_cfg_edge, eedge, loc_info, op)
   {
   }
 
@@ -525,8 +512,9 @@ class catch_cfg_edge_event : public cfg_edge_event
 public:
   catch_cfg_edge_event (const exploded_edge &eedge,
 			const event_loc_info &loc_info,
+			const control_flow_op &op,
 			tree type)
-  : cfg_edge_event (event_kind::catch_, eedge, loc_info),
+  : cfg_edge_event (event_kind::catch_, eedge, loc_info, &op),
     m_type (type)
   {
   }
@@ -545,6 +533,23 @@ private:
   tree m_type;
 };
 
+struct critical_state
+{
+  critical_state ()
+  : m_var (NULL_TREE),
+    m_state (nullptr)
+  {
+  }
+  critical_state (tree var, state_machine::state_t state)
+  : m_var (var),
+    m_state (state)
+  {
+  }
+
+  tree m_var;
+  state_machine::state_t m_state;
+};
+
 /* A concrete event subclass for an interprocedural call.  */
 
 class call_event : public superedge_event
@@ -561,17 +566,27 @@ public:
   const program_state *
   get_program_state () const final override;
 
+  /* Mark this edge event as being either an interprocedural call or
+     return in which VAR is in STATE, and that this is critical to the
+     diagnostic (so that print_desc can attempt to get a better description
+     from any pending_diagnostic).  */
+  void record_critical_state (tree var, state_machine::state_t state)
+  {
+    m_critical_state = critical_state (var, state);
+  }
+
 protected:
   tree get_caller_fndecl () const;
   tree get_callee_fndecl () const;
 
   const supernode *m_src_snode;
   const supernode *m_dest_snode;
+  critical_state m_critical_state;
 };
 
 /* A concrete event subclass for an interprocedural return.  */
 
-class return_event : public superedge_event
+class return_event : public checker_event
 {
 public:
   return_event (const exploded_edge &eedge,
@@ -582,8 +597,26 @@ public:
 
   bool is_return_p () const final override;
 
+  const call_and_return_op *
+  get_call_and_return_op () const
+  {
+    return m_call_and_return_op;
+  }
+
+  /* Mark this edge event as being either an interprocedural call or
+     return in which VAR is in STATE, and that this is critical to the
+     diagnostic (so that print_desc can attempt to get a better description
+     from any pending_diagnostic).  */
+  void record_critical_state (tree var, state_machine::state_t state)
+  {
+    m_critical_state = critical_state (var, state);
+  }
+
+  const exploded_edge &m_eedge;
   const supernode *m_src_snode;
   const supernode *m_dest_snode;
+  const call_and_return_op *m_call_and_return_op;
+  critical_state m_critical_state;
 };
 
 /* A concrete event subclass for the start of a consolidated run of CFG
diff --git a/gcc/analyzer/common.h b/gcc/analyzer/common.h
index ac3048c796e..a2d903cbe17 100644
--- a/gcc/analyzer/common.h
+++ b/gcc/analyzer/common.h
@@ -23,6 +23,7 @@ along with GCC; see the file COPYING3.  If not see
 
 #include "config.h"
 #define INCLUDE_MAP
+#define INCLUDE_SET
 #define INCLUDE_STRING
 #define INCLUDE_VECTOR
 #include "system.h"
@@ -49,14 +50,6 @@ namespace ana {
 class supergraph;
 class supernode;
 class superedge;
-  class cfg_superedge;
-    class switch_cfg_superedge;
-    class eh_dispatch_cfg_superedge;
-      class eh_dispatch_try_cfg_superedge;
-      class eh_dispatch_allowed_cfg_superedge;
-  class callgraph_superedge;
-    class call_superedge;
-    class return_superedge;
 
 class svalue;
   class region_svalue;
@@ -119,14 +112,13 @@ class checker_event;
 class checker_path;
 class extrinsic_state;
 class sm_state_map;
-class stmt_finder;
 class program_point;
-class function_point;
 class program_state;
 class exploded_graph;
 class exploded_node;
 class exploded_edge;
 class feasibility_problem;
+class feasibility_state;
 class exploded_cluster;
 class exploded_path;
 class analysis_plan;
@@ -145,6 +137,7 @@ class call_summary;
 class call_summary_replay;
 struct per_function_data;
 struct interesting_t;
+class uncertainty_t;
 
 class feasible_node;
 
@@ -163,6 +156,12 @@ extern int tree_cmp (const void *p1, const void *p2);
 extern tree fixup_tree_for_diagnostic (tree);
 extern tree get_diagnostic_tree_for_gassign (const gassign *);
 
+inline bool
+useful_location_p (location_t loc)
+{
+  return get_pure_location (loc) != UNKNOWN_LOCATION;
+}
+
 /* A tree, extended with stack frame information for locals, so that
    we can distinguish between different values of locals within a potentially
    recursive callstack.  */
@@ -296,6 +295,15 @@ class known_function
 public:
   virtual ~known_function () {}
   virtual bool matches_call_types_p (const call_details &cd) const = 0;
+
+  /* A hook for performing additional checks on the expected state
+     at a call.  */
+  virtual void
+  check_any_preconditions (const call_details &) const
+  {
+    // no-op
+  }
+
   virtual void impl_call_pre (const call_details &) const
   {
     return;
@@ -388,6 +396,10 @@ public:
   /* Hook for making .dot label more readable.  */
   virtual void print (pretty_printer *pp) const = 0;
 
+  virtual void
+  get_dot_attrs (const char *&out_style,
+		 const char *&out_color) const;
+
   /* Hook for updating STATE when handling bifurcation.  */
   virtual bool update_state (program_state *state,
 			     const exploded_edge *eedge,
@@ -400,7 +412,8 @@ public:
 			     region_model_context *ctxt) const = 0;
 
   virtual void add_events_to_path (checker_path *emission_path,
-				   const exploded_edge &eedge) const = 0;
+				   const exploded_edge &eedge,
+				   pending_diagnostic &pd) const = 0;
 
   virtual exploded_node *create_enode (exploded_graph &eg,
 				       const program_point &point,
@@ -485,6 +498,7 @@ extern bool is_longjmp_call_p (const gcall &call);
 extern bool is_placement_new_p (const gcall &call);
 extern bool is_cxa_throw_p (const gcall &call);
 extern bool is_cxa_rethrow_p (const gcall &call);
+extern bool is_cxa_end_catch_p (const gcall &call);
 
 extern const char *get_user_facing_name (const gcall &call);
 
diff --git a/gcc/analyzer/constraint-manager.cc b/gcc/analyzer/constraint-manager.cc
index c8cc71593cc..4b8dae029dd 100644
--- a/gcc/analyzer/constraint-manager.cc
+++ b/gcc/analyzer/constraint-manager.cc
@@ -930,53 +930,6 @@ bounded_ranges_manager::consolidate (bounded_ranges *inst)
   return inst;
 }
 
-/* Get the bounded_ranges instance for EDGE of SWITCH_STMT,
-   creating it if necessary, and caching it by edge.  */
-
-const bounded_ranges *
-bounded_ranges_manager::
-get_or_create_ranges_for_switch (const switch_cfg_superedge *edge,
-				 const gswitch *switch_stmt)
-{
-  /* Look in per-edge cache.  */
-  if (const bounded_ranges ** slot = m_edge_cache.get (edge))
-    return *slot;
-
-  /* Not yet in cache.  */
-  const bounded_ranges *all_cases_ranges
-    = create_ranges_for_switch (*edge, switch_stmt);
-  m_edge_cache.put (edge, all_cases_ranges);
-  return all_cases_ranges;
-}
-
-/* Get the bounded_ranges instance for EDGE of SWITCH_STMT,
-   creating it if necessary, for edges for which the per-edge
-   cache has not yet been populated.  */
-
-const bounded_ranges *
-bounded_ranges_manager::
-create_ranges_for_switch (const switch_cfg_superedge &edge,
-			  const gswitch *switch_stmt)
-{
-  /* Get the ranges for each case label.  */
-  auto_vec <const bounded_ranges *> case_ranges_vec
-    (gimple_switch_num_labels (switch_stmt));
-
-  for (tree case_label : edge.get_case_labels ())
-    {
-      /* Get the ranges for this case label.  */
-      const bounded_ranges *case_ranges
-	= make_case_label_ranges (switch_stmt, case_label);
-      case_ranges_vec.quick_push (case_ranges);
-    }
-
-  /* Combine all the ranges for each case label into a single collection
-     of ranges.  */
-  const bounded_ranges *all_cases_ranges
-    = get_or_create_union (case_ranges_vec);
-  return all_cases_ranges;
-}
-
 /* Get the bounded_ranges instance for CASE_LABEL within
    SWITCH_STMT.  */
 
diff --git a/gcc/analyzer/constraint-manager.h b/gcc/analyzer/constraint-manager.h
index 38686b7e696..4e3b3967cbc 100644
--- a/gcc/analyzer/constraint-manager.h
+++ b/gcc/analyzer/constraint-manager.h
@@ -172,20 +172,13 @@ template <> struct default_hash_traits<bounded_ranges::key_t>
 
 namespace ana {
 
-/* An object to own and consolidate bounded_ranges instances.
-   This also caches the mapping from switch_cfg_superedge
-   bounded_ranges instances, so that get_or_create_ranges_for_switch is
-   memoized.  */
+/* An object to own and consolidate bounded_ranges instances.  */
 
 class bounded_ranges_manager
 {
 public:
   ~bounded_ranges_manager ();
 
-  const bounded_ranges *
-  get_or_create_ranges_for_switch (const switch_cfg_superedge *edge,
-				   const gswitch *switch_stmt);
-
   const bounded_ranges *get_or_create_empty ();
   const bounded_ranges *get_or_create_point (const_tree value);
   const bounded_ranges *get_or_create_range (const_tree lower_bound,
@@ -200,15 +193,11 @@ public:
 
   void log_stats (logger *logger, bool show_objs) const;
 
-private:
-  const bounded_ranges *
-  create_ranges_for_switch (const switch_cfg_superedge &edge,
-			    const gswitch *switch_stmt);
-
   const bounded_ranges *
   make_case_label_ranges (const gswitch *switch_stmt,
 			  tree case_label);
 
+private:
   const bounded_ranges *consolidate (bounded_ranges *);
 
   struct hash_traits_t : public typed_noop_remove<bounded_ranges *>
@@ -241,10 +230,6 @@ private:
   };
   typedef hash_map<bounded_ranges *, bounded_ranges *, traits_t> map_t;
   map_t m_map;
-
-  typedef hash_map<const switch_cfg_superedge *,
-		   const bounded_ranges *> edge_cache_t;
-  edge_cache_t m_edge_cache;
 };
 
 /* An equivalence class within a constraint manager: a set of
